# ![WfExS-backend:](development-docs/logo/WfExS-logo-final_paths.svg) Workflow Execution Service backend documentation

This page holds pointers to additional documentation and demos about the system, due its growing complexity.

## Original documentation

This documentation is already pointed from [root README.md](../README.md):

* [INSTALL.md](../INSTALL.md): In order to use WfExS-backend you have to install first at least core dependencies described there.

* [TODO.md](../TODO.md): This development is relevant for projects like [EOSC-Life](https://www.eosc-life.eu/) or [EJP-RD](https://www.ejprarediseases.org/). The list of high level scheduled and pending developments can be seen at .

* [README_LIFECYCLE.md](../README_LIFECYCLE.md): WfExS-backend analysis lifecycle and usage scenarios are briefly described with flowcharts there.

* [README_REPLICATOR.md](../README_REPLICATOR.md): It briefly describes `WfExS-config-replicator.py` usage.

## Cache handling

Examples and some explanations about cached contents handling within WfExS-backend are available at [cache-handling.md](cache-handling.md).

Examples of fetching from command line are available at [../fetchers-tests/test-recipes.md](../fetchers-tests/test-recipes.md).

## Staged working directories handling

Examples and some explanations about staged working directories handling within WfExS-backend will be available at [workdir-handling.md](workdir-handling.md).